#ifndef morpheo_behavioural_generic_victim_victim_pseudo_lru_Parameters_h
#define morpheo_behavioural_generic_victim_victim_pseudo_lru_Parameters_h

/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/include/Parameters.h"
#include <math.h>

namespace morpheo {
namespace behavioural {
namespace generic {
namespace victim {
namespace victim_pseudo_lru {


  class Parameters : public morpheo::behavioural::Parameters
  {
    //-----[ fields ]------------------------------------------------------------
  public : const uint32_t _nb_entity ; // number of entity
  public : const uint32_t _nb_access ; // number of port to select an entity
  public : const uint32_t _nb_update ; // number of port to update the internal entity
  public : const uint32_t _size_table; // Size of victim_pseudo_lru's table

    //-----[ methods ]-----------------------------------------------------------
  public : Parameters  (uint32_t nb_entity ,
			uint32_t nb_access ,
			uint32_t nb_update ,
			uint32_t size_table);
  public : Parameters  (Parameters & param) ;
  public : ~Parameters () ;

  public :        std::string   msg_error  (void);
  public :        std::string   print      (uint32_t depth);
  public : friend std::ostream& operator<< (std::ostream& output_stream,
					    morpheo::behavioural::generic::victim::victim_pseudo_lru::Parameters & x);
  };

}; // end namespace victim_pseudo_lru
}; // end namespace victim
}; // end namespace generic

}; // end namespace behavioural
}; // end namespace morpheo              

#endif
